The first three chapters introduce the various selectors, focusing on the list text to tree structure of the graph

# Processor class

[list2mermaid]
- text--TextProcessor-->text
- text--RenderProcessor-->element
- element--DecorateProcessor-->element

# More Processor（Decorate Processor）

## Block Name

**This is quite useful and high frequency**，and I gave you a grammar candy: start with `#` 
Give the block a name, and you can automatically identify the type of the modified block. It can easily be:
- Add to table: Center table title
- Add to code: filename

#### Table heading

[2table|#table heading]
- 1| 2
- 3| 4

#### code file name

**According to the reason, the file name should be the same color as the code block. If the color is different, I will adjust it in the css file.**
find `--pre-background-color` ，at css file the fifth line，just change the color value.
（Tried using js to get code block color again, but failed）

[#main.cpp]
```c
#include <stdio.h>
 
int main()
{
    printf("Hello, World! \n");
 
    return 0;
}

```

#### ohter block name

[#quote block name]
> 111
> 222

[#list block name]
- 1
	- 2
		- 3
	- 2


## fold

This is the code I used to force the list2table effect with dataviewjs before writing anyblock. The content is long, so here to demonstrate

[fold]
```js
const keyword = "%"+"toTable" // 不能合并
const files = app.vault.getMarkdownFiles()


const lines = files
	.filter((file) => {  // 本篇笔记
		return file.path == dv.current().file.path
	})
	.map(async (file) => {  // 转列表
		const content = await app.vault.cachedRead(file)  
		const lines = content.split("\n")
		return lines
	})
	
Promise.all(lines).then(linesTmp => {
	let lines = linesTmp.flat()

	// 先搜索关键词
	let index = 0
	for(let i=0; i<lines.length; i++){
		if(lines[i].contains(keyword)){
			index = i
			break
		}
	}
	
	// 获取参数
	const args = lines[index].replace(keyword, "").replace(/^|/, "").split("|")
	

	// 先不考虑异常缩进了
	let levelArr = []
	let contentArr = []
	for(let i=index+1; i<lines.length; i++){
		if(/^\s*?-\s(.*?)/.test(lines[i])){
			contentArr.push(lines[i].replace(/^\s*?-\s/, ""))
			levelArr.push(lines[i].replace(/-\s(.*?)$/, "").length/2)
		}
		else{
			break
		}
	}

	// 再弄成正确的层次关系，暂时先只考虑三层
	let tableData = []
	let lastArr = []
	let lastLevel = 0
	for(let i=0; i<levelArr.length; i++){
		if(levelArr[i]==0){
			if(lastArr.length!=0) {// 是否不为第一个数据
				tableData.push(lastArr)
				lastArr = []
			}
			lastLevel = 0
			lastArr.push(contentArr[i])
		}
		else if(levelArr[i]==1){
			if (lastLevel<1){ // 是否新起一行
				lastArr.push(contentArr[i])
				lastLevel = 1
			}
			else{
				tableData.push(lastArr)
				lastArr = []
				lastLevel = 1
				lastArr.push("^^")
				lastArr.push(contentArr[i])
			}
		}
		else if(levelArr[i]==2){
			if (lastLevel<2){ // 是否新起一行
				lastArr.push(contentArr[i])
				lastLevel = 2
			}
			else{
				tableData.push(lastArr)
				lastArr = []
				lastLevel = 2
				lastArr.push("^^")
				lastArr.push("^^")
				lastArr.push(contentArr[i])
			}
		}
	}
	tableData.push(lastArr)
	lastArr = []
	
	console.log(tableData)
	dv.table(args, tableData)
})  



```

## 溢出折叠

Like many blogs, there are overflow collapses of code blocks. AnyBlock also has this processor, whether it's a block of code or something else.
**Notes are useful when writing down long blocks of code**
（@todo This does not match the light pattern, and does not necessarily match the user's code block background）

[overfold]
```js
const&nbsp;keyword&nbsp;=&nbsp;"%"+"toTable" // 不能合并
const&nbsp;files&nbsp;=&nbsp;app.vault.getMarkdownFiles()


const&nbsp;lines&nbsp;=&nbsp;files
	.filter((file) => {  // 本篇笔记
		return file.path == dv.current().file.path
	})
	.map(async&nbsp;(file)&nbsp;=>&nbsp;{  // 转列表
		const&nbsp;content&nbsp;=&nbsp;await&nbsp;app.vault.cachedRead(file)  
		const&nbsp;lines&nbsp;=&nbsp;content.split("\n")
		return&nbsp;lines
	})
	
Promise.all(lines).then(linesTmp&nbsp;=> {
	let lines = linesTmp.flat()

	// 先搜索关键词
	let index = 0
	for(let i=0; i<lines.length; i++){
		if(lines[i].contains(keyword)){
			index = i
			break
		}
	}
	
	// 获取参数
	const args = lines[index].replace(keyword, "").replace(/^|/, "").split("|")
	

	// 先不考虑异常缩进了
	let levelArr = []
	let contentArr = []
	for(let i=index+1; i<lines.length; i++){
		if(/^\s*?-\s(.*?)/.test(lines[i])){
			contentArr.push(lines[i].replace(/^\s*?-\s/, ""))
			levelArr.push(lines[i].replace(/-\s(.*?)$/, "").length/2)
		}
		else{
			break
		}
	}

	// 再弄成正确的层次关系，暂时先只考虑三层
	let tableData = []
	let lastArr = []
	let lastLevel = 0
	for(let i=0; i<levelArr.length; i++){
		if(levelArr[i]==0){
			if(lastArr.length!=0) {// 是否不为第一个数据
				tableData.push(lastArr)
				lastArr = []
			}
			lastLevel = 0
			lastArr.push(contentArr[i])
		}
		else if(levelArr[i]==1){
			if (lastLevel<1){ // 是否新起一行
				lastArr.push(contentArr[i])
				lastLevel = 1
			}
			else{
				tableData.push(lastArr)
				lastArr = []
				lastLevel = 1
				lastArr.push("^^")
				lastArr.push(contentArr[i])
			}
		}
		else if(levelArr[i]==2){
			if (lastLevel<2){ // 是否新起一行
				lastArr.push(contentArr[i])
				lastLevel = 2
			}
			else{
				tableData.push(lastArr)
				lastArr = []
				lastLevel = 2
				lastArr.push("^^")
				lastArr.push("^^")
				lastArr.push(contentArr[i])
			}
		}
	}
	tableData.push(lastArr)
	lastArr = []
	
	console.log(tableData)
	dv.table(args, tableData)
})  

```


[list2table|overfold]
- < 大类型| 解析方法 | 解析方法zh | 渲染方法 | 渲染方法zh | 可转md/html
- tree
	- ul-list| ul树
	  （一叉多层树）
		- 2ut/2mdut       | 转表格（规范） | md/html
	- li-list| li树
	  （一叉多层树）
		- 2lt/mdlt        | 转列表格 | html
	- ab-tree | 二层树
	  也叫 "消除最高级"
	  （一叉二层树）
		- 2timeline | 转时间线 | mermaid
		- 2tab         | 转标签栏 | html
		- 2chat       | 转对话
	- tree-list | 树列表
	  （多叉多层树）
		- 2table/2mdtable | 转树表格 | html
		- 2mermaid  | 转流程图   | mermaid/html
		- 2mindmap  | 转思维导图      | html
		- 2tree     | 长得像树的树状图 | html
		- 2xuri     | 旭日图         | html
		- 2brace    | 括弧分类图      | html
- other
	- title       | 标题级（语法糖）
		- 2list+list2xxx | (组合使用，下面提供了几种语法糖)
		- 2tab
		- 2table
		- 2mindmap
	- code      | 一定代码
		- 2doctable | 转表格（文档生成） | html
		- json | 这个不能转树，只能说转可折叠渲染
	- common    | 通用
		- text | 纯文本            | md
		- md   | md渲染            | md
	- render| 渲染
	  （理论上为 "渲染修饰器"
	  但该功能没做）
		- flod | (折叠类)可折叠     | md+
		- hide | (折叠类)默认折叠   | md+
		- heimu| (折叠类)黑幕遮挡   | html
		- limit()/part() | (折叠类)限高折叠 | html
		- scroll()| (折叠类)限高滚动 | html
		- title()| 增加块标题（代码块可能会很常用）
## Scroll

The default is to scroll beyond 460px，The processor can also accept arguments，`scroll(How much more becomes a roll)`，Parameters do not need to be added `px`

[scroll]
```js
const keyword = "%"+"toTable" // 不能合并
const files = app.vault.getMarkdownFiles()


const lines = files
	.filter((file) => {  // 本篇笔记
		return file.path == dv.current().file.path
	})
	.map(async (file) => {  // 转列表
		const content = await app.vault.cachedRead(file)  
		const lines = content.split("\n")
		return lines
	})
	
Promise.all(lines).then(linesTmp => {
	let lines = linesTmp.flat()

	// 先搜索关键词
	let index = 0
	for(let i=0; i<lines.length; i++){
		if(lines[i].contains(keyword)){
			index = i
			break
		}
	}
	
	// 获取参数
	const args = lines[index].replace(keyword, "").replace(/^|/, "").split("|")
	

	// 先不考虑异常缩进了
	let levelArr = []
	let contentArr = []
	for(let i=index+1; i<lines.length; i++){
		if(/^\s*?-\s(.*?)/.test(lines[i])){
			contentArr.push(lines[i].replace(/^\s*?-\s/, ""))
			levelArr.push(lines[i].replace(/-\s(.*?)$/, "").length/2)
		}
		else{
			break
		}
	}

	// 再弄成正确的层次关系，暂时先只考虑三层
	let tableData = []
	let lastArr = []
	let lastLevel = 0
	for(let i=0; i<levelArr.length; i++){
		if(levelArr[i]==0){
			if(lastArr.length!=0) {// 是否不为第一个数据
				tableData.push(lastArr)
				lastArr = []
			}
			lastLevel = 0
			lastArr.push(contentArr[i])
		}
		else if(levelArr[i]==1){
			if (lastLevel<1){ // 是否新起一行
				lastArr.push(contentArr[i])
				lastLevel = 1
			}
			else{
				tableData.push(lastArr)
				lastArr = []
				lastLevel = 1
				lastArr.push("^^")
				lastArr.push(contentArr[i])
			}
		}
		else if(levelArr[i]==2){
			if (lastLevel<2){ // 是否新起一行
				lastArr.push(contentArr[i])
				lastLevel = 2
			}
			else{
				tableData.push(lastArr)
				lastArr = []
				lastLevel = 2
				lastArr.push("^^")
				lastArr.push("^^")
				lastArr.push(contentArr[i])
			}
		}
	}
	tableData.push(lastArr)
	lastArr = []
	
	console.log(tableData)
	dv.table(args, tableData)
})  



```

## black curtain

It is similar to the dark screen effect of Mengniang Encyclopedia

[X|addClass(ab-deco-heimu)]
> This is a piece of content that cannot be seen directly
> ...
> ...

## add class / add div

`addClass` (Adds a class name to the current block)、`addDiv` (Append a parent element and append a class name to the parent element)
This can be used to add a custom style to the block (like an `ad` plugin) that can be extended by users who know CSS

# Custom processor

A few processor configurations are recommended to know how to use them.
id and name are arbitrary. Let me show you

[2table]
- Registry matching name| The register is replaced with
- quote|     add([!quote])|quote
- fold |     add([!note]-|qutoe)
- `/mindmap(.*?)/`| rootlist(%1)|mindmap

`%n` ndicates that the n TH match in the regular is replaced at this position
In the example of the map above，`mindmap(name)` will being `rootlist(name)|mindmap`

The functionality is relatively simple and less powerful than adding processors in code. But by combining registries, you can still make nice customization

